unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RVRTF, RVRTFErr, Menus, StdCtrls, RVTypes;

type
  TForm1 = class(TForm)
    Memo1: TMemo;                         
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    procedure Open1Click(Sender: TObject);
  private
    { Private declarations }
    FirstLine: Boolean;
    procedure DoReaderText(Sender: TRVRTFReader; const Text: TRVAnsiString;
      Position: TRVRTFPosition);
  public
    { Public declarations }
    RTFText: TRVAnsiString;
    function ExtractTextFromRTF(const FileName: String): Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

function TForm1.ExtractTextFromRTF(const FileName: String): Boolean;
var parser: TRVRTFReader;
begin
  RTFText := '';
  FirstLine := True;
  parser := TRVRTFReader.Create(nil);
  try
    parser.OnNewText := DoReaderText;
    Result := parser.ReadFromFile(FileName)=rtf_ec_OK;
  finally
    parser.Free;
  end;
end;

procedure TForm1.DoReaderText(Sender: TRVRTFReader; const Text: TRVAnsiString;
  Position: TRVRTFPosition);
begin
  if (Position<>rtf_ts_ContinuePara) and not FirstLine then
    RTFText := RTFText+#13#10;
  FirstLine := False;
  RTFText := RTFText+Text;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    if ExtractTextFromRTF(OpenDialog1.FileName) then
      Memo1.Lines.Text := RTFText
    else
      ShowMessage('Error loading file');
end;

end.
